package il.co.cortext.rui.examples;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;

public class RadioBoxExample {
	
	private Label label1, label2;
	private Group group1, group2;

	public static void main(String [] args) {
		Display display = new Display();
		Shell shell = new RadioBoxExample().open(display);
		while (!shell.isDisposed())
			if (!display.readAndDispatch()) display.sleep();
		display.dispose();
	}

	public Shell open(Display display) {
		Shell shell = new Shell(display);
		shell.setLayout(new GridLayout(2, false));

		label1 = new Label(shell, SWT.LEFT);
		label2 = new Label(shell, SWT.LEFT);
		label1.setText("foo1");
		label2.setText("foo2");

		group1       = new Group(shell, SWT.NONE);
		Button foo1  = new Button(group1, SWT.RADIO);
		Button bar1  = new Button(group1, SWT.RADIO);
		Button baz1  = new Button(group1, SWT.RADIO);
		group1.setLayout(new GridLayout());
		group1.setText("group1");
		foo1.setText("foo1");
		bar1.setText("bar1");
		baz1.setText("baz1");
		foo1.setSelection(true);
		SelectionListener selectionListener1 = new SelectionAdapter () {
			public void widgetSelected (SelectionEvent event) {
				Button source = (Button) event.widget; 
				if (source.getSelection()) label1.setText(source.getText());
			};
		};
		foo1.addSelectionListener(selectionListener1);
		bar1.addSelectionListener(selectionListener1);
		baz1.addSelectionListener(selectionListener1);

		group2 = new Group(shell, SWT.NONE);
		group2.setLayout(new GridLayout());
		Button foo2  = new Button(group2, SWT.RADIO);
		Button bar2  = new Button(group2, SWT.RADIO);
		Button baz2  = new Button(group2, SWT.RADIO);
		group2.setText("group2");
		foo2.setText("foo2");
		bar2.setText("bar2");
		baz2.setText("baz2");
		foo2.setSelection(true);
		SelectionListener selectionListener2 = new SelectionAdapter () {
			public void widgetSelected (SelectionEvent event) {
				Button source = (Button) event.widget;
				if (source.getSelection()) label2.setText(source.getText());
			};
		};
		foo2.addSelectionListener(selectionListener2);
		bar2.addSelectionListener(selectionListener2);
		baz2.addSelectionListener(selectionListener2);

		shell.pack();
		shell.open();
		return shell;
	}

}
