package il.co.cortext.rui.examples;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

public class TextAreaExample {

	private Label label;
	private Text textIn, textOut;

	public static void main(String [] args) {
		Display display = new Display();
		Shell shell = new TextAreaExample().open(display);
		while (!shell.isDisposed())
			if (!display.readAndDispatch()) display.sleep();
		display.dispose();
	}

	public Shell open(Display display) {
		Shell shell = new Shell(display);
		shell.setLayout(new GridLayout(1, false));

		label = new Label(shell, SWT.CENTER);
		label.setText("type text in the top text area, then focus out");
		label.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));

		textIn = new Text(shell, SWT.MULTI | SWT.BORDER);
		textIn.setLayoutData(new GridData(GridData.FILL_BOTH));

		textOut = new Text(shell, SWT.MULTI | SWT.BORDER);
		textOut.setLayoutData(new GridData(GridData.FILL_BOTH));
		textOut.setEnabled(false);

		textIn.addModifyListener(new ModifyListener() {
			public void modifyText(ModifyEvent e)
				{ textOut.setText(textIn.getText()); }
		});

		shell.pack();
		shell.open();
		return shell;
	}

}
