package il.co.cortext.rui.examples;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Tree;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.TreeItem;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;


public class TreeExample {

	private Label label;
	private Tree tree;	

	public static void main(String [] args) throws Exception{
		Display display = new Display();
		Shell shell = new TreeExample().open(display);
		while (!shell.isDisposed ())
			if (!display.readAndDispatch ()) display.sleep();
		display.dispose();
	}

	private void setChildren(TreeItem parentItem, int size) {
		TreeItem tempItem;
		for (int i = size-1; i >= 0; i--) {
			tempItem = new TreeItem(parentItem,SWT.CENTER,0);
			tempItem.setText(parentItem.getText() + "." + i);
		}
	}
	
	public Shell open(Display display) throws Exception {
		Shell shell = new Shell(display);
		shell.setLayout(new GridLayout(1, false));
		label = new Label(shell, SWT.CENTER);
		label.setText("Click item to change me");
		label.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		

		tree = new Tree(shell,SWT.BORDER | SWT.H_SCROLL | SWT.V_SCROLL);
		tree.setLayoutData(new GridData(GridData.FILL_BOTH));

		TreeItem treeItem = new TreeItem(tree,SWT.CENTER,0);
		treeItem.setText(" Child 0");

		setChildren(treeItem,5);
		setChildren((treeItem.getItems())[2],4);
		setChildren((((treeItem.getItems())[2]).getItems())[3],4);

		tree.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e)
				{ label.setText(tree.getSelection()[0].getText()); }
		});

		shell.pack();
		shell.open();
		return shell;
	}

}
