package il.co.cortext.rui.examples.phonebook;


import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

public class ContactEditor {

	private ContactModel input;
	private Text         nameField, phoneField;
	private Composite    parent;

	public ContactEditor(Composite parent, ContactModel input) {
		this.input        = input;
		this.parent       = parent;
		GridLayout layout = new GridLayout(2, false);
		Composite panel   = new Composite(parent, SWT.BORDER);
		Label nameLabel   = new Label(panel, SWT.NONE);
		nameField         = new Text(panel, SWT.BORDER | SWT.SINGLE);
		Label phoneLabel  = new Label(panel, SWT.RIGHT);
		phoneField        = new Text(panel, SWT.BORDER | SWT.SINGLE);
		panel.setLayout(layout);
		nameLabel.setText("name:");
		phoneLabel.setText("phone:");
		nameField.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		phoneField.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		nameField.addModifyListener(new ModifyListener()
			{ public void modifyText(ModifyEvent e) { setName(); } }
		);
		phoneField.addModifyListener(new ModifyListener()
			{ public void modifyText(ModifyEvent e) { setPhone(); } }
		);
		refresh();		
	}

	public void setInput(ContactModel input) {
		this.input = input;
		refresh();
	}

	private void refresh() {
		if (input == null) {
			nameField.setText("");
			phoneField.setText("");
			parent.setEnabled(false);
			
		} else {
			parent.setEnabled(true);
			nameField.setText(input.getName());
			phoneField.setText(input.getPhone());
		}
	}

	private void setName()
		{ if (input != null) input.setName(nameField.getText()); }

	private void setPhone()
		{ if (input != null) input.setPhone(phoneField.getText()); }
}
