package il.co.cortext.rui.examples.widget;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.TabFolder;

public class ButtonTab extends Tab {

	private Group alignGroup, imageGroup, eventGroup;
	private Button button1, button2, button3;

	public Composite createTabFolderPage(TabFolder tabFolder) throws Exception {
		Composite tabFolderPage = new Composite(tabFolder, SWT.NONE);
		tabFolderPage.setLayout(new GridLayout());

		alignGroup = createGroup(tabFolderPage, "alignment", true);
		imageGroup = createGroup(tabFolderPage, "image"    , false);
		eventGroup = createGroup(tabFolderPage, "event"    , false);

		button1 = new Button(alignGroup, SWT.LEFT);
		button2 = new Button(alignGroup, SWT.CENTER);
		button3 = new Button(alignGroup, SWT.RIGHT);
		button1.setText("Left");
		button2.setText("Center with tooltip");
		button3.setText("Right disabled");
		button2.setToolTipText("centered button");
		button3.setEnabled(false);

		button1 = new Button(imageGroup, SWT.CENTER);
		button2 = new Button(imageGroup, SWT.CENTER);
		button3 = new Button(imageGroup, SWT.CENTER);
		button1.setImage(new Image(null, "eg/Square.gif"));
		button1.setBackground(new Color(null, 255, 255, 255));
		button2.setImage(new Image(null, "eg/Triangle.gif"));
		button2.setBackground(new Color(null, 255, 255, 255));
		button3.setImage(new Image(null, "eg/Circle.gif"));
		button3.setBackground(new Color(null, 255, 255, 255));

		button1 = new Button(eventGroup, SWT.CHECK);
		button1.setText("click to change text");
		button1.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				button1.setText("checkbox value is " + button1.getSelection());
				eventGroup.layout();
			}
		});

		return tabFolderPage;
	}

	String getTabText() { return "Button"; }

}
