package il.co.cortext.rui.examples.widget;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.TabFolder;

public class LabelTab extends Tab {

	private Group alignGroup, colorGroup, imageGroup;
	private Label label1, label2, label3;

	public Composite createTabFolderPage(TabFolder tabFolder) throws Exception {
		Composite tabFolderPage = new Composite(tabFolder, SWT.NONE);
		tabFolderPage.setLayout(new GridLayout());

		alignGroup = createGroup(tabFolderPage, "alignment", true);
		colorGroup = createGroup(tabFolderPage, "color"    , false);
		imageGroup = createGroup(tabFolderPage, "image"    , false);

		label1 = new Label(alignGroup, SWT.LEFT);
		label2 = new Label(alignGroup, SWT.CENTER);
		label3 = new Label(alignGroup, SWT.RIGHT);
		label1.setText("Left");
		label2.setText("Center with tooltip");
		label3.setText("Right disabled");
		label2.setToolTipText("centered label");
		label3.setEnabled(false);

		label1 = new Label(colorGroup, SWT.CENTER);
		label2 = new Label(colorGroup, SWT.CENTER);
		label3 = new Label(colorGroup, SWT.CENTER);
		label1.setText("Red on white");
		label2.setText("White on blue");
		label3.setText("Yellow on black");
		label1.setForeground(new Color(null, 255, 0, 0));
		label1.setBackground(new Color(null, 255, 255, 255));
		label2.setForeground(new Color(null, 255, 255, 255));
		label2.setBackground(new Color(null, 0, 0, 255));
		label3.setForeground(new Color(null, 255, 255, 0));
		label3.setBackground(new Color(null, 0, 0, 0));
		
		label1 = new Label(imageGroup, SWT.CENTER);
		label2 = new Label(imageGroup, SWT.CENTER);
		label3 = new Label(imageGroup, SWT.CENTER);
		label1.setImage(new Image(null, "eg/Square.gif"));
		label1.setBackground(new Color(null, 255, 255, 255));
		label2.setImage(new Image(null, "eg/Triangle.gif"));
		label2.setBackground(new Color(null, 255, 255, 255));
		label3.setImage(new Image(null, "eg/Circle.gif"));
		label3.setBackground(new Color(null, 255, 255, 255));

		return tabFolderPage;
	}

	String getTabText() { return "Label"; }

}
