package il.co.cortext.rui.examples.widget;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.TabFolder;
import org.eclipse.swt.widgets.List;
import org.eclipse.swt.widgets.Combo;

public class ListTab extends Tab {

	private Group singleGroup, multiGroup;
	private Combo single;
	private List multi;

	public Composite createTabFolderPage(TabFolder tabFolder) throws Exception {
		Composite tabFolderPage = new Composite(tabFolder, SWT.NONE);
		tabFolderPage.setLayout(new GridLayout());

		singleGroup = createGroup(tabFolderPage, "single line", true);
		multiGroup  = createGroup(tabFolderPage, "multi line" , true);
		single      = new Combo(singleGroup, SWT.READ_ONLY | SWT.DROP_DOWN);
		multi       = new List(multiGroup, SWT.BORDER | SWT.H_SCROLL | SWT.V_SCROLL);
		for (int i = 0; i < 10; i++) {
			single.add("Item #" + i);
			multi.add("Item #" + i);
		}
		multiGroup.setLayoutData(new GridData(GridData.FILL_BOTH));

		return tabFolderPage;
	}

	String getTabText() { return "List"; }

}
