package il.co.cortext.rui.examples.widget;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.TabFolder;
import org.eclipse.swt.widgets.TabItem;

public class WidgetExample {

	public static void main(String [] args) throws Exception {
		Display display = new Display();
		Shell shell = new WidgetExample().open(display);
		while (!shell.isDisposed())
			if (!display.readAndDispatch()) display.sleep();
		display.dispose();
	}

	public Shell open(Display display) throws Exception {
		Shell shell = new Shell(display);
		shell.setLayout(new FillLayout());

		TabFolder tabFolder = new TabFolder(shell, SWT.NONE);
		Tab[] tabs = new Tab[] {
			new ButtonTab(),
			new LabelTab(),
			new ListTab(),
			new SashFormTab(),
			new TextTab(),
			new TreeTab(),
		};
		for (int i = 0; i < tabs.length; i++) {
			TabItem item = new TabItem(tabFolder, SWT.NULL);
			item.setText(tabs[i].getTabText());
			item.setControl(tabs[i].createTabFolderPage(tabFolder));
		}

		shell.layout();
		shell.open();
		return shell;
	}

}
