package il.co.cortext.rui.remote;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.StringTokenizer;

public class RuiApplicationManager {

	private Map applicationMap;
	
	public RuiApplicationManager(String applicationMapSource)
		throws Exception {
		setApplicationMapSource(applicationMapSource);		
	}
	
	public void start(String applicationName) throws Exception {
		assert applicationMap != null;
		if (applicationName == null || applicationName.equals(""))
			applicationName = "DEFAULT";
		if (!applicationMap.containsKey(applicationName))
			throw new Exception("Unknown application name: " + applicationName);
		String applicationClassName =
			(String) applicationMap.get(applicationName);
		Object[] args = {new String[0]};
		Class.
			forName(applicationClassName).
			getMethod("main", new Class[] {String[].class}).
			invoke(null, args);
	}
	
	private void setApplicationMapSource(String applicationMapSource) {
		applicationMap = new HashMap();
		StringBuffer applicationMapRaw = new StringBuffer();
		for (int i=0; i < applicationMapSource.length(); ++i) {
			char c = applicationMapSource.charAt(i);
			if (!Character.isWhitespace(c)) applicationMapRaw.append(c);
		}
		StringTokenizer tokenizer =
			new StringTokenizer(applicationMapRaw.toString(), ";");
		ArrayList entries = new ArrayList();
		while (tokenizer.hasMoreTokens()) entries.add(tokenizer.nextToken());
		for (Iterator iter = entries.iterator(); iter.hasNext();) {
			String entry = (String) iter.next();
			tokenizer = new StringTokenizer(entry, ",");
			ArrayList pair = new ArrayList();
			while (tokenizer.hasMoreTokens()) pair.add(tokenizer.nextToken());
			applicationMap.put(pair.get(0), pair.get(1));
		}
	}


}
