package il.co.cortext.rui.remote;

import java.util.Map;
import java.util.HashMap;

public class RuiClientEvenManager {

	private Map listeners = new HashMap();
	
	public void setListener(String sourceId, IRuiClientListener listener) {
		listeners.put(sourceId, listener);
	}
	
	public void removeListener(String sourceId) {
		if (!listeners.containsKey(sourceId))
			throw new IllegalArgumentException("Unknown listener: " + sourceId);
		listeners.remove(sourceId);
	}
	
	public void fireEvent(RuiClientEvent event) throws Exception {
		String sourceId = event.getValue("sourceId");
		String name = event.getValue("name");
		if (sourceId == null || sourceId.equals(""))
			throw new IllegalArgumentException("Event with no source");
		if (name == null || name.equals(""))
			throw new IllegalArgumentException("Event with no name");
		if (!listeners.containsKey(sourceId))
			throw new IllegalArgumentException("Posthomous event: " + sourceId);
		((IRuiClientListener) listeners.get(sourceId)).handleClientEvent(event);
	}

}
