package il.co.cortext.rui.remote;

import java.io.StringReader;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;

public class RuiClientEvent extends HashMap {

	private String sourceXml;

	public RuiClientEvent(String in) throws Exception { setXML(in); }
	
	public RuiClientEvent(Map in) throws Exception {
		String xml = "<rui>";
		for (Iterator i = in.keySet().iterator(); i.hasNext();) {
			String key   = (String) i.next();
			Object value = in.get(key);
			String stringValue = value instanceof String?
				(String) value:
				((String []) value)[0];
			xml += "<" + key + ">" + stringValue + "</" + key + ">";
		}
		setXML(xml + "</rui>");
	}
	
	private void setXML(String in) throws Exception {
		sourceXml = in;
		Document document = DocumentBuilderFactory.newInstance().newDocumentBuilder().
					parse( new InputSource(new StringReader(in)) );
		
		NodeList nodes = document.getFirstChild().getChildNodes();
		for (int i = 0; i < nodes.getLength(); i++) {
			Node node = nodes.item(i);
			put(node.getNodeName(), node.getFirstChild().getNodeValue());
		}
	}

	public String getValue(String key) throws Exception
		{ return (String) get(key); }

	public String toString() { return sourceXml; }

}
