package il.co.cortext.rui.remote;

public class RuiServerCommand {

	final private static char WORD_SEPERATOR = (char) 1;
	final private static char LINE_SEPERATOR = (char) 2;

	String className;
	String methodName;
	String windowId;
	String widgetId;
	String[] params;
	
	public RuiServerCommand(
		String className, String methodName, String windowId, String[] params
	) {
		setData(className, methodName, windowId, null, params);
	}
	
	public RuiServerCommand(
		String className, String methodName, String windowId, String widgetId,
		String[] params
	) {
		setData(className, methodName, windowId, widgetId, params);
	}
	
	private void setData(
		String className, String methodName, String windowId, String widgetId,
		String[] params
	) {
		this.className  = className;
		this.methodName = methodName;
		this.windowId   = windowId;
		this.widgetId   = widgetId;
		this.params     = params;
	}
	
	public String toString() {
		String out =
			className  + WORD_SEPERATOR +
			methodName + WORD_SEPERATOR +
			windowId   +  
			(widgetId != null? WORD_SEPERATOR + widgetId: "");
		if (params != null)
			for (int i = 0; i < params.length; i++)
				out +=
					WORD_SEPERATOR +
					(params[i] == null? "": params[i]).
						replace(WORD_SEPERATOR, ' ').
						replace(LINE_SEPERATOR, ' ');
		return out + LINE_SEPERATOR;
	}

	public static String translateToText(String in) {
		return in.
			replace(LINE_SEPERATOR, '\n').
			replace(WORD_SEPERATOR, '.');
	}

}
