package il.co.cortext.rui.remote;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringReader;
import java.io.StringWriter;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.eclipse.swt.graphics.Image;

public class RuiServlet extends HttpServlet {

	private static RuiSessionManager sessionManager =
		RuiSessionManager.getInstance();

	public void init() throws ServletException { try {
		Image.localPathPrefix =
			getServletContext().getRealPath("/images") + "/";
		sessionManager.setApplicationManager
			(new RuiApplicationManager(getInitParameter("applicationMap")));
	} catch (Exception e) { throw new ServletException(e); }}

	protected void doPost (
		HttpServletRequest request, HttpServletResponse response
	) throws ServletException, IOException {

		response.setContentType("text/html");
		PrintWriter out = response.getWriter();
		try {
			RuiClientEvent event;

			int contentLength = request.getContentLength();
			if (contentLength > 0) {
				char[] eventXmlChars = new char[contentLength];
				request.getReader().read(eventXmlChars);
				event = new RuiClientEvent(new String(eventXmlChars));
			} else {
				event = new RuiClientEvent(request.getParameterMap());
			}

			out.println(sessionManager.handleRequest(event));

		} catch (Throwable e) {
			e.printStackTrace();
			out.println("Error:");
			out.println(getFilteredTrace(e));
		} finally { out.close(); }

	}

	protected void doGet (
		HttpServletRequest request, HttpServletResponse response
	) throws ServletException, IOException { doPost(request, response); }

	// copied from junit source
	static boolean filterLine(String line) {
		String[] patterns= new String[] {
			"org.apache.tomcat",
			"org.apache.catalina",
			"org.apache.coyote",
		};
		for (int i= 0; i < patterns.length; i++) {
			if (line.indexOf(patterns[i]) > 0)
				return true;
		}
		return false;
	}

	public static String getFilteredTrace(Throwable t) {
		StringWriter sw = new StringWriter();
		PrintWriter pw  = new PrintWriter(sw);
		t.printStackTrace(pw);
		StringBuffer buffer = sw.getBuffer();
		String trace = buffer.toString();
		return filterStack(trace);
	}

	public static String filterStack(String stack) {
		StringWriter sw   = new StringWriter();
		PrintWriter pw    = new PrintWriter(sw);
		StringReader sr   = new StringReader(stack);
		BufferedReader br = new BufferedReader(sr);

		String line;
		try {
			while ((line= br.readLine()) != null) {
				if (!filterLine(line))
					pw.println(line);
			}
		} catch (Exception IOException) {
			return stack; // return the stack unfiltered
		}
		return sw.toString();
	}


}
