package org.eclipse.swt.custom;

import org.eclipse.swt.*;
import org.eclipse.swt.widgets.*;


public class SashForm extends Composite {

	private int orientation;

	public SashForm(Composite parent, int style) {
		super(parent, style);
		// need to set layout explicitly because layout manager is null
		setOrientation
			(((style & SWT.VERTICAL) != 0)? SWT.VERTICAL: SWT.HORIZONTAL);
	}	
	
// accessing ------------------------------------------------------------------

	public int getOrientation() { return orientation; }
	
	public void setOrientation(int orientation) {
		if (this.orientation == orientation) return;
		if (orientation != SWT.HORIZONTAL && orientation != SWT.VERTICAL)
			SWT.error(SWT.ERROR_INVALID_ARGUMENT);
		this.orientation = orientation;
		sendToClient(
			METHOD_LAYOUTMANAGER,
			FIELDNAME_ORIENT,
			orientation == SWT.VERTICAL?
				FIELDVALUE_VERTICAL: FIELDVALUE_HORIZONTAL
		);
	}

// template methods -----------------------------------------------------------

	protected String getDefaultProxyClassName() { return CLASS_SPLITPANEL; }

	
}