package org.eclipse.swt.graphics;

import org.eclipse.swt.SWT;

public class Color {

	public RGB handle;

	Color() {}

	public Color(Device device, int red, int green, int blue)
		{ this(device, new RGB(red, green, blue)); }

	public Color(Device device, RGB rgb) {
		if (rgb == null) SWT.error(SWT.ERROR_NULL_ARGUMENT);
		handle = rgb;
	}

	public void dispose() {}

	public boolean equals(Object object) {
		if (object == this) return true;
		if (!(object instanceof Color)) return false;
		Color color = (Color) object;
		return color.handle.equals(this.handle);
	}

	public int getRed()         { return handle.red; }
	public int getGreen()       { return handle.green; }
	public int getBlue()        { return handle.blue; }
	public RGB getRGB()         { return handle; }
	public int hashCode()       { return handle.hashCode(); }
	public boolean isDisposed() { return false; }

	public String toString() {
		return "Color {" + getRed() + ", " + getGreen() + ", " + getBlue() + "}";
	}

}
