package org.eclipse.swt.graphics;

import java.io.FileInputStream;

import il.co.cortext.rui.util.ImageInfo;

public class Image implements Drawable {

	public static String localPathPrefix = "";

	private String url;
	private int    width, height;

	Image () {}

	public Image (Device device, String fileName) throws Exception {
		url                  = "images/" + fileName;
		String localFileName = localPathPrefix + fileName;
		ImageInfo info       = new ImageInfo();
		FileInputStream in   = new FileInputStream(localFileName);
		info.setInput(in);
		if (!info.check())
			throw new Exception("Invalid image: " + localFileName);
		width  = info.getWidth();
		height = info.getHeight();
		in.close();
	}
 
	public void dispose () {}

	public String toString () {
		return
			"Image {filename=" + url + ",width=" +
			width + ",height=" + height +"}";
	}

	public String getFileName() { return url; }
	public int getHeight()      { return height; }
	public int getWidth()       { return width; }

// mock methods for SWT compatibility -----------------------------------------

	public boolean isDisposed() { return false; }

}
