package org.eclipse.swt.layout;

import java.util.HashMap;
import java.util.Map;

import org.eclipse.swt.widgets.Layout;

public final class GridLayout extends Layout {

	public int numColumns                = 1;
	public int horizontalSpacing         = 5;
	public int verticalSpacing           = 5;
	public boolean makeColumnsEqualWidth = false;

	public GridLayout () {}

	public GridLayout(int numColumns, boolean makeColumnsEqualWidth) {
		this.numColumns            = numColumns;
		this.makeColumnsEqualWidth = makeColumnsEqualWidth;
	}

	protected String getName() { return "grid"; }

	protected Map getState() {
		Map state = new HashMap();
		state.put("numCols",  "" + numColumns);
		state.put("hSpacing", "" + horizontalSpacing);
		state.put("vSpacing", "" + verticalSpacing);
		state.put("equalWidth", makeColumnsEqualWidth? "1": "0");
		return state;
	}

	protected Map mapChildLayoutData(Object layoutData)
		{ return ((GridData) layoutData).getState(); }

}
