package org.eclipse.swt.layout;

import java.util.HashMap;
import java.util.Map;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Point;

public final class RowData {

	public int width;
	public int height;

	public RowData() { this (SWT.DEFAULT, SWT.DEFAULT); }
	
	public RowData(int width, int height) {
		this.width  = width;
		this.height = height;
	}
	
	public RowData(Point point) {
		this(point.x, point.y);
	}

	public Map getState() {
		Map state = new HashMap();
		if (width  != SWT.DEFAULT) state.put("width",  "" + width);
		if (height != SWT.DEFAULT) state.put("height", "" + height);
		return state;
	}

}
