package org.eclipse.swt.widgets;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Image;

public class Label extends Control {

	private String text;
	private Image image;

	public Label(Composite parent, int style) { super(parent, style); }

// accessing ------------------------------------------------------------------

	public Image  getImage() { return image; }
	public String getText () { return text;  }

	public void setText(String text) {
		this.text = text;
		sendToClient(getSetTextProxyMethodName(), text);
	}

	public void setImage(Image image) {
		this.image = image;
		sendToClient(METHOD_IMAGEURL,    image.getFileName());
		sendToClient(METHOD_IMAGEWIDTH,  "" + image.getWidth());
		sendToClient(METHOD_IMAGEHEIGHT, "" + image.getHeight());
	}

// style ----------------------------------------------------------------------

	public int getAlignment() {
		if ((style & SWT.SEPARATOR) != 0) return 0;
		if ((style & SWT.LEFT)      != 0) return SWT.LEFT;
		if ((style & SWT.CENTER)    != 0) return SWT.CENTER;
		if ((style & SWT.RIGHT)     != 0) return SWT.RIGHT;
		return SWT.LEFT;
	}

	public void setAlignment(int alignment) {
		if ((style & SWT.SEPARATOR) != 0) return;
		if ((alignment & (SWT.LEFT | SWT.RIGHT | SWT.CENTER)) == 0) return;
		style &= ~(SWT.LEFT | SWT.RIGHT | SWT.CENTER);
		style |= alignment & (SWT.LEFT | SWT.RIGHT | SWT.CENTER);
		sendToClient(METHOD_HALIGN,
			(style & SWT.RIGHT)  != 0? "right":
			(style & SWT.CENTER) != 0? "center":
			"left"
		);
	}

// template methods -----------------------------------------------------------

	protected void setStyle() {
		super.setStyle();
		int alignment = getAlignment();
		if (alignment != SWT.NONE) setAlignment(alignment);
	}

	protected String getDefaultProxyClassName () { return CLASS_LABEL;    }
	protected String getSetTextProxyMethodName() { return METHOD_SETTEXT; }

}
