package org.eclipse.swt.widgets;

import il.co.cortext.rui.remote.RuiClientEvent;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ModifyListener;

public class Text extends Control {

	private String text;

	public Text(Composite parent, int style) { super(parent, style); }

	public String getText() { return text; }

	public void setText(String text) {
		this.text = text;
		sendToClient(METHOD_SETTEXT, text);
	}

// event handling -------------------------------------------------------------

	public void addModifyListener(ModifyListener listener) {
		if (listener == null) error(SWT.ERROR_NULL_ARGUMENT);
		TypedListener typedListener = new TypedListener(listener);
		addListener(SWT.Modify, typedListener);
	}

	public void removeModifyListener(ModifyListener listener) {
		if (listener == null) error(SWT.ERROR_NULL_ARGUMENT);
		if (eventTable == null) return;
		eventTable.unhook(SWT.Modify, listener);
	}

// template methods -----------------------------------------------------------

	protected Event translateEvent(RuiClientEvent clientEvent)
		throws Exception {
		text = clientEvent.getValue("value");
		Event event = new Event();
		event.type = SWT.Modify;
		return event;
	}

	protected String getDefaultProxyClassName()
		{ return (style & SWT.SINGLE) != 0? CLASS_TEXTFIELD: CLASS_TEXTAREA; }

}
