package il.co.cortext.rui.remote.tests;

import java.util.HashMap;

import junit.framework.TestCase;

import il.co.cortext.rui.remote.IRuiClientListener;
import il.co.cortext.rui.remote.RuiClientEvenManager;
import il.co.cortext.rui.remote.RuiClientEvent;

public class RuiClientEvenManagerTest extends TestCase {

	private RuiClientEvenManager subject;
	private RuiClientEvent event;
	
	public RuiClientEvenManagerTest(String name) { super(name); }
	
	public void testFireEvent() throws Exception {
		subject = new RuiClientEvenManager();
		event = null;
		IRuiClientListener listener = new IRuiClientListener() {
			public void handleClientEvent(RuiClientEvent inEvent) {
				event = inEvent;
			}
		};
		subject.setListener("E1", listener);
		HashMap map = new HashMap();
		map.put("sessionId", "1234");
		map.put("name", "Click");
		map.put("sourceId", "E1");
		subject.fireEvent(new RuiClientEvent(map));
		if (event == null) fail("No event");
		assertEquals(event.getValue("sessionId"), "1234");
		assertEquals(event.getValue("name"), "Click");
		assertEquals(event.getValue("sourceId"), "E1");
		subject.removeListener("E1");	
		
	}

}
