package il.co.cortext.rui.remote.tests;

import junit.framework.TestCase;
import il.co.cortext.rui.remote.RuiServerCommand;
import il.co.cortext.rui.remote.RuiServerCommandBuffer;

public class RuiServerCommandBufferTest extends TestCase {

	private RuiServerCommandBuffer subject;

	public RuiServerCommandBufferTest(String name) { super(name); }

	public void testFlushBuffer() {
		subject = new RuiServerCommandBuffer();
		String[] params2 = {"G", "H"};
		String[] params4 = {"Q", "R"};
		RuiServerCommand command1 =
			new RuiServerCommand("A", "B", "C", new String[0]);
		RuiServerCommand command2 =
			new RuiServerCommand("D", "E", "F", params2);
		RuiServerCommand command3 =
			new RuiServerCommand("I", "J", "K", "L", new String[0]);
		RuiServerCommand command4 =
			new RuiServerCommand("M", "N", "O", "P", params4);
		subject.addCommand(command1);
		subject.addCommand(command2);
		subject.addCommand(command3);
		subject.addCommand(command4);
		assertEquals(
			"A.B.C\nD.E.F.G.H\nI.J.K.L\nM.N.O.P.Q.R\n",
			RuiServerCommand.translateToText(subject.flush())
		);
	}

}
