package il.co.cortext.rui.remote.tests;

import il.co.cortext.rui.remote.RuiApplicationManager;
import il.co.cortext.rui.remote.RuiClientEvent;
import il.co.cortext.rui.remote.RuiSession;
import il.co.cortext.rui.remote.RuiSessionManager;
import java.util.HashMap;

import junit.framework.TestCase;

public class RuiSessionManagerTest extends TestCase {

	private RuiSessionManager subject;

	public RuiSessionManagerTest(String name) { super(name); }

	public void testHandleRequest() throws Exception {
		subject = RuiSessionManager.getInstance();
		subject.setApplicationManager(
			new RuiApplicationManager(
				"DEFAULT  , il.co.cortext.rui.remote.tests.RuiMockApplication;"
			)
		);

		HashMap map = new HashMap();
		map.put("requestType", RuiSession.BOOT_REQUEST);
		RuiClientEvent bootEvent = new RuiClientEvent(map);

		RuiMockApplication.reset();
		String message1 = subject.handleRequest(bootEvent);

		assertTrue(RuiMockApplication.getFlag());
		assertTrue(message1.startsWith("S"));
		assertTrue(message1.endsWith("\n"));

		RuiMockApplication.reset();

		String message2 = subject.handleRequest(bootEvent);

		assertTrue(RuiMockApplication.getFlag());
		assertTrue(message2.startsWith("S"));
		assertTrue(message2.endsWith("\n"));

		RuiMockApplication.reset();
		subject.reset();
	}

}
