package il.co.cortext.rui.remote.tests;

import il.co.cortext.rui.remote.IRuiClientListener;
import il.co.cortext.rui.remote.RuiApplicationManager;
import il.co.cortext.rui.remote.RuiClientEvent;
import il.co.cortext.rui.remote.RuiServerCommand;
import il.co.cortext.rui.remote.RuiSession;
import java.util.HashMap;

import junit.framework.TestCase;

public class RuiSessionTest extends TestCase {

	private RuiSession subject;

	public RuiSessionTest(String name) { super(name); }

	public void testSession() throws Exception {
		String sessionId = "1234";
		subject = new RuiSession(
			new RuiApplicationManager(
				"DEFAULT , il.co.cortext.rui.remote.tests.RuiMockApplication;"
			),
			sessionId
		);
		HashMap map = new HashMap();
		map.put("requestType", RuiSession.BOOT_REQUEST);
		RuiClientEvent bootEvent = new RuiClientEvent(map);

		RuiMockApplication.reset();
		subject.handleRequest(bootEvent);
		assertTrue(RuiMockApplication.getFlag());
		RuiMockApplication.reset();

		map = new HashMap();
		map.put("requestType", RuiSession.EVENT_REQUEST);
		map.put("name", "Click");
		map.put("sourceId", "E1");
		RuiClientEvent event = new RuiClientEvent(map);

		subject.setListener("E1", new IRuiClientListener() {
			public void handleClientEvent(RuiClientEvent event) throws Exception {
				assertEquals("Click", event.getValue("name"));
				assertEquals("E1", event.getValue("sourceId"));
				subject.addCommand
					(new RuiServerCommand("A", "B", "C", new String[0]));
			}
		});

		subject.handleRequest(event);
		assertEquals(
			"A.B.C\n",
			RuiServerCommand.translateToText(subject.flush())
		);
		assertEquals(
			"",
			RuiServerCommand.translateToText(subject.flush())
		);
		assertEquals(true, subject.showsActivity(1000000000));
		Thread.sleep(11);
		assertEquals(false, subject.showsActivity(10));
	}

}
