package org.eclipse.swt.custom.tests;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.tests.CompositeTest;
import org.eclipse.swt.custom.SashForm;
import il.co.cortext.rui.remote.IRuiConstants;

public class SashFormTest extends CompositeTest {

	private static final String VERTICAL   = IRuiConstants.FIELDNAME_ORIENT + "." +	IRuiConstants.FIELDVALUE_VERTICAL;
	private static final String HORIZONTAL = IRuiConstants.FIELDNAME_ORIENT + "." +	IRuiConstants.FIELDVALUE_HORIZONTAL;

	private SashForm subject;

	public SashFormTest(String name) { super(name); }
	
	protected void setUp() throws Exception {
		super.setUp();
		subject = (SashForm) getSubject();
	}

	public void testCreateWithOrientation() {
		SashForm sashForm = new SashForm(subject, SWT.HORIZONTAL);
		assertBufferMatches
			(sashForm, IRuiConstants.METHOD_LAYOUTMANAGER, HORIZONTAL);
		assertEquals(sashForm.getOrientation(), SWT.HORIZONTAL);

		sashForm = new SashForm(subject, SWT.VERTICAL);
		assertBufferMatches
			(sashForm, IRuiConstants.METHOD_LAYOUTMANAGER, VERTICAL);
		assertEquals(sashForm.getOrientation(), SWT.VERTICAL);
	}

	public void testGetOrientation(){
		assertEquals(subject.getOrientation(), SWT.HORIZONTAL);

		subject.setOrientation(SWT.VERTICAL);
		assertBufferMatches
			(subject, IRuiConstants.METHOD_LAYOUTMANAGER, VERTICAL);
		assertEquals(subject.getOrientation(), SWT.VERTICAL);

		subject.setOrientation(SWT.HORIZONTAL);
		assertBufferMatches
			(subject, IRuiConstants.METHOD_LAYOUTMANAGER, HORIZONTAL);
		assertEquals(subject.getOrientation(), SWT.HORIZONTAL);
	}

// template methods -----------------------------------------------------------

	protected Class getSubjectClass() { return SashForm.class; }
	
}
