package org.eclipse.swt.widgets.tests;

import il.co.cortext.rui.remote.RuiApplicationManager;
import il.co.cortext.rui.remote.RuiClientEvent;
import il.co.cortext.rui.remote.RuiServerCommand;
import il.co.cortext.rui.remote.RuiSession;
import il.co.cortext.rui.remote.RuiSessionManager;
import il.co.cortext.rui.remote.tests.RuiMockApplication;
import java.util.HashMap;
import java.util.Map;

public class ControlTestHelper {

	protected RuiSession session;
	protected RuiSessionManager sessionManager;

	public ControlTestHelper() throws Exception {
		sessionManager = RuiSessionManager.getInstance();
		sessionManager.setApplicationManager(new RuiApplicationManager(
			"DEFAULT , il.co.cortext.rui.remote.tests.RuiMockApplication;"
		));
		HashMap map = new HashMap();
		map.put("requestType", RuiSession.BOOT_REQUEST);
		sessionManager.handleRequest(new RuiClientEvent(map));
		session = sessionManager.getSessionById("S1");
		sessionManager.attachSessionToThread(session);
	}

	public void tearDown() {
		sessionManager.reset();
		RuiMockApplication.reset();
	}

	public String flush()
		{ return RuiServerCommand.translateToText(session.flush()); }

	public void fireEvent(Map event) throws Exception {
		event.put("sessionId", session.getId());
		event.put("requestType", RuiSession.EVENT_REQUEST);
		sessionManager.handleRequest(new RuiClientEvent(event));
		sessionManager.attachSessionToThread(session);
	}

}
