package org.eclipse.swt.widgets.tests;

import il.co.cortext.rui.remote.IRuiConstants;

import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Shell;

public class ShellTest extends CompositeTest {

	Shell subject;

	public ShellTest(String name) { super(name); }

	protected void setUp() throws Exception {
		super.setUp();
		subject = (Shell) getSubject();
		shell = subject;
	}

// shell tests ----------------------------------------------------------------

	public void testCreate() throws Exception {
		subject = (Shell) makeSubject();
		assertBufferMatches(subject, IRuiConstants.METHOD_CREATE, null);
	}

	public void testGetShell() throws Exception
		{ assertEquals(subject, subject.getShell()); }

	public void testSetText() throws Exception {
		subject.setText("foo");
		assertEquals("foo", subject.getText());
		assertBuffer(subject, IRuiConstants.METHOD_TITLE, "foo");
		subject.setText("bar");
		assertEquals("bar", subject.getText());
		assertBuffer(subject, IRuiConstants.METHOD_TITLE, "bar");
	}

// testing helpers ------------------------------------------------------------

	protected Control makeSubject() throws Exception {
		Object[] args = {display};
		return makeSubject(args);
	}

// template methods -----------------------------------------------------------

	protected Control getDelegate(Control subject)
		{ return ((Shell) subject).getMainPanel(); }

	protected String getCommandId(Control subject) {
		return subject instanceof Shell?
			subject.getWindowId():
			super.getCommandId(subject);
	}

	protected Class getSubjectClass() { return Shell.class; }

}
