package org.eclipse.swt.widgets.tests;

import il.co.cortext.rui.remote.IRuiConstants;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.TabFolder;
import org.eclipse.swt.widgets.TabItem;

public class TabFolderTest extends ControlTestCase {

	private TabFolder subject;

	public TabFolderTest(String name) { super(name); }

	protected void setUp() throws Exception {
		super.setUp();
		subject = (TabFolder) getSubject();
	}


// creation methods -----------------------------------------------------------

	public void testCreate() throws Exception {
		subject                  = (TabFolder) makeSubject();
		Composite noteBookHeader = (Composite) subject.getChildren()[0];
		Composite stack          = (Composite) subject.getChildren()[1];
		Object[][] results = {
			{subject,        IRuiConstants.METHOD_CREATE, "E1"},
			{noteBookHeader, IRuiConstants.METHOD_CREATE, "E5"},
			{stack,          IRuiConstants.METHOD_CREATE, "E5"},
		};
		assertBufferMatches(results);
	}

	public void testTabItem() throws Exception {
		subject = (TabFolder) getSubject();
		for (int i = 1; i < 4; i++) {
			TabItem item = new TabItem(subject, SWT.NONE);
			Label label  = new Label(subject, SWT.CENTER);
			item.setText("foo" + i);
			label.setText("bar" + i);
			Object[][] results = {
				{item,  IRuiConstants.METHOD_CREATE,  "E3"},
				{item,  IRuiConstants.METHOD_SETTEXT, "foo" + i},
				{label, IRuiConstants.METHOD_CREATE,  "E4"},
				{label, IRuiConstants.METHOD_SETTEXT, "bar" + i},
			};
			assertBufferMatches(results);
		}
	}

// template methods -----------------------------------------------------------

	protected Class getSubjectClass() { return TabFolder.class; }

}
