#!perl -w

use FindBin;
use lib "$FindBin::Bin/../../../base/perllib";

use Rui;
use strict;
use File::Path;
use Pod::Find qw(pod_find);
use Pod::Html;

$| = 1;

my $root     = "$Rui::PROJECT_HOME";
my $inRoot   = $root. '/perllib';
my $outRoot  = $root. '/doc';
my %pods     = pod_find("$inRoot");
my $podCount = 0;
my $contents;

foreach my $file (sort keys %pods) {

	$podCount++;
	my $module = $pods{$file};
	print "$podCount) Processing $module\n";

	my $file;
	($file = $module) =~ s|::|/|g;
	my $inFile  = "$inRoot/$file.pm";
	my $outFile = "$outRoot/$file.html";

	my $outPath;
	($outPath = $outFile) =~ s|/\w+\.html$||;
	mkpath($outPath) unless -e $outPath;

	my $htmlRoot = './';
	my $depth = $module;
	$depth = ($depth =~ tr/\://)/2;
	$htmlRoot .= '../' x $depth;
	$htmlRoot =~ s|/$||;

	pod2html(
		"--infile=$inFile",
		"--outfile=$outFile",
		"--htmlroot=$htmlRoot",
		"--css=$htmlRoot/style/pods.css",
	);

	$contents.= "<li><a href=\"$file.html\">$module</a></li>";
}

my $indexPage = <<"INDEX_PAGE";
<html>
<head>
<base target="DOC">
<title>Table of Contents</title>
</head>
<body>
<ol>
CONTENTS
</ol>
</body>
</html>
INDEX_PAGE

$indexPage =~ s/CONTENTS/$contents/;

open(F,">$outRoot/toc.html");
print F $indexPage;
close(F);

__END__
		
