package Rui::Application::eg::Group;

use base 'Rui::Application::Base';

my @ColorLevels = qw(ff 77 00);

sub start
{
	my $self = shift;
	$self->layoutManager(name => 'fill');
	my $topGroup = $self->Group(
		value         => 'Top Group',
		layoutManager => {name => 'grid', numCols => 3},
	);
	foreach my $row (1..3) {
		foreach my $col (1..3) {
			$topGroup->Group(
				value         => "Group $row.$col",
				layoutHint    => {fill => 1, flex => 1},
				layoutManager => {name => 'fill'},
			)->Label(
				value         => "Inside Group $row.$col",
				hAlign        => 'left',
				style         => {
					backgroundColor => 
						'#22'. $ColorLevels[$row-1]. $ColorLevels[3-$col],
					border          => '1px solid #000000',
				},
			);
		}
	}
}

1;

__END__

