package Rui::Application::eg::Widget::Base;

use Carp;
use Attribute::Protected;
use Rui::Image;

use base 'Rui::Widget::Panel';

my @Colors          = ("#FF0000", "#00FF00", "#0000FF");
my @ColorNames      = qw(Red Green Blue);
my @AntiColors      = ("#0000FF", "#FF0000", "#00FF00");
my @AntiColorNames  = qw(Blue Red Green);

my @Shapes          = qw(Circle Triangle Square);
my %ShapeColorNames = (Circle => 'Red', Triangle => 'Green', Square => 'Blue');

my $Images = {

	(map { $_ => Rui::Image->new(
		file => "icons/$_.gif",
		size => [16, 16],
	) } qw(Delete Folder)),

	(Background => Rui::Image->new(
		file => 'eg/Background.jpg',
		size => [120, 120],
	)),

	(map { $_ => Rui::Image->new(
		file => "eg/$_.gif",
		size => [16, 16],
	) } @Shapes),

	(map { $ShapeColorNames{$_} => Rui::Image->new(
		file => "eg/$_.gif",
		size => [16, 16],
	) } @Shapes),

};


sub getDemoShapes         : Protected { \@Shapes }
sub getDemoImages         : Protected { $Images }
sub getDemoColors         : Protected { \@Colors }
sub getDemoColorNames     : Protected { \@ColorNames }
sub getDemoAntiColors     : Protected { \@AntiColors }
sub getDemoAntiColorNames : Protected { \@AntiColorNames }

1;

