package Rui::Application::eg::Widget::HTMLEditor;

use Carp;
use Attribute::Protected;
use Rui::Model::Value;

use base 'Rui::Application::eg::Widget::Base';

sub populate : Protected
{
	my $self = shift;
	$self->layoutManager(name => 'grid');

	$self->Label(
		value    => 'Enter text in top area, format with buttons, then focus out',
		cssClass => 'InfoLabel',
	);

	my $model = Rui::Model::Value->new;
	$self->HTMLEditor(
		model      => $model,
		layoutHint => {fill => 1, flex => 1},
	);
	$self->TextArea(
		model      => $model,
		layoutHint => {fill => 1, flex => 1},
		readOnly   => 1,
	);
}

1;

