package Rui::Application::eg::Widget::NoteBook;

use Carp;
use Attribute::Protected;

use base 'Rui::Application::eg::Widget::Base';

sub populate : Protected
{
	my $self = shift;
	$self->layoutManager(name => 'fill');
	my $noteBook = $self->NoteBook;
	$noteBook->getStack->style(padding => '0px');

	foreach my $i (1..3) {
		$noteBook->Tab(
			value   => "Page $i",
			tooltip => "click to switch to page #$i",
			image   => $self->getDemoImages->{
				$self->getDemoAntiColorNames->[$i-1]
			},
			style              => {
				color           => $self->getDemoAntiColors->[$i-1],
				backgroundColor => $self->getDemoColors->[$i-1],
				fontWeight      => 'bold',
				fontSize        => '20px',
			},
		);
		$noteBook->Page->layoutManager(name => 'fill')->Label(
			hAlign             => 'center',
			value              => "Inside page $i",
			style              => {
				color           => $self->getDemoAntiColors->[$i-1],
				backgroundColor => $self->getDemoColors->[$i-1],
				fontWeight      => 'bold',
				fontSize        => '40px',
				fontFamily      => 'serif',
				padding         => '20px 0px 0px 0px',
				margin          => '0px 0px 0px 0px',
			},
		);
	}
}

1;
