package Rui::Application::eg::Widget::SplitPanel;

use Carp;
use Attribute::Protected;

use base 'Rui::Application::eg::Widget::Base';

sub populate : Protected
{
	my $self = shift;
	$self->layoutManager(name => 'fill');
	my %commonStyle = (
		margin     => '0px 0px 0px 0px',
		padding    => '6px 6px 6px 6px',
		border     => '2px solid #000000',
		fontSize   => '20px',
		fontWeight => 'bold',
	);

	my $panel1 = $self->SplitPanel(layoutManager => {orient => 'vertical'});
	$panel1->Label(
		value => 'Top',
		style => {backgroundColor => $self->getDemoColors->[0], %commonStyle},
	);

	my $panel2 = $panel1->SplitPanel;
	$panel2->Label(
		value => 'Left',
		style => {backgroundColor => $self->getDemoColors->[1], %commonStyle},
	);
	$panel2->Label(
		value => 'Right',
		style => {backgroundColor => $self->getDemoColors->[2], %commonStyle},
	);
}

1;

