package Rui::Application::eg::Widget::TextField;

use Carp;
use Attribute::Protected;

use base 'Rui::Application::eg::Widget::Base';

sub populate : Protected
{
	my $self = shift;
	$self->
		layoutManager(name => 'grid', numCols => 2)->
		style(
			border  => '2px groove threedhighlight',
			padding => '3px 3px 3px 3px',
		);

	$self->
		layoutManager(name => 'grid', numCols => 2)->
		style(border => '2px groove threedhighlight');

	$self->Label(value => 'Enter some text');
	my $input1 = $self->
		TextField(layoutHint => {hFlex => 1, hAlign=> 'fill'}, value => '');

	$self->Label(value => 'Enter a password');
	my $input2 = $self->
		PasswordField(layoutHint => {hAlign=> 'fill'}, value => '');

	$self->Label(value => 'Enter some more text')->
		layoutHint(vAlign => 'top');
	my $input3 = $self->
		TextArea(layoutHint => {hAlign=> 'fill', minHeight => 60}, value => '');

	my $output;
	$self->Button(value => 'Join everything')->addListener(Click => sub {
		$output->model->value(
			join "\n", map { $_->model->value } ($input1, $input2, $input3)
		)
	})->layoutHint(vAlign => 'top');
	$output = $self->
		TextArea(layoutHint => {flex => 1, fill => 1})->readOnly(1);
}

1;

