package Rui::Application::eg::Widget::Tree;

use Carp;
use Attribute::Protected;

use Rui::Model::TreeNode;
use Rui::Model::SelectionInTree;

use base 'Rui::Application::eg::Widget::Base';

sub populate : Protected
{
	my $self = shift;
	$self->{images} = [
		map { $self->getDemoImages->{$_} } qw(Circle Square Triangle)
	];
	my $label = $self->Label(value => 'Select node to change me');
	$self->layoutManager(name => 'grid');

	my $protoNode = Rui::Model::TreeNode->new;
	my $model = Rui::Model::SelectionInTree->new(root => $protoNode->new(
			value => 'RootNode',  
			data  => [
				$protoNode->new(
					value => 'Child 0',
					data  => [
						$protoNode->new(value => 'Grandchild 0.0'),
						$protoNode->new(value => 'Grandchild 0.1'),
					],
				),
				$protoNode->new(
					value => 'Child 1',
					data  => [
						$protoNode->new(value => 'Grandchild 1.0'),
						$protoNode->new(value => 'Grandchild 1.1'),
						$protoNode->new(value => 'Grandchild 1.2'),
					],
				
				),
				$protoNode->new(
					value => 'Child 2',
					data  => [map {
						my $outerIndex = $_;
						$protoNode->new(
							value => "Grandchild 2.$outerIndex",
							data  => [map {
								my $innerIndex = $_;
								$protoNode->new(
									value => "node 2.$outerIndex.$innerIndex",
									data  => [map {
										$protoNode->new(value =>
											"node 2.$outerIndex.$innerIndex.$_",
										)
									} (0..2)],
								)
							} (0..2)],
						)
					} (0..2)],
				),
			],
	));

	$self->Tree(
		layoutHint => {flex => 1, fill => 1},
		model      => $model,
		renderer   => $self,
	);

	$model->selection->addListener(Change => sub {
		$label->value(shift->value->value)
	});
}

sub render
{
	my ($self, $node) = @_;
	return {
		value => $node->value,
		image => $self->{images}->[int rand 3],
	};
}

1;


