package Rui::Mock::Session;

use Carp;
use Attribute::Protected;

use base 'Rui::Remote::Session';

# creating -----------------------------------------------------------------

sub init
{
	my $self = shift;
	$self->SUPER::init('mock', {});
}

# server interface ---------------------------------------------------------

sub flushBuffer
{
	my $self = shift;
	my $buffer = $self->{buffer};
	$self->{buffer} = "";
	return "$buffer";
}

# server widgets interface -------------------------------------------------

sub appendToBuffer : Protected
{
	my ($self, $message) = @_;
	my $wordSeperator = chr(1);
	my $lineSeperator = chr(2);
	for ($message) {
		s/$lineSeperator/\n/g;
		s/$wordSeperator/./g;
	}
	$self->SUPER::appendToBuffer($message);
}

# --------------------------------------------------------------------------

1;

