
package Rui::Model::Base;

use base 'Rui::Event::Listenable';

# creating -----------------------------------------------------------------

sub erase
{
	my $self = shift;
	$self->detach;
	$self->fireEvent(Rui::Event->new(
		name   => 'Erase',
		source => $self,
	));
}

# --------------------------------------------------------------------------

1;

=head1 NAME

Rui::Model::Base - abstract base class for models

=head1 SYNOPSIS

  my $model = SomeModel->new(
     events => {
        EventName => $listener,
     ...
  );
  $model->addListener(EventName => $listener);
  $model->removeListener(EventName => $listener);
  $model->erase;

=head1 SUPERCLASS

L<Rui::Event::Listenable>

=head1 DESCRIPTION

Models are listenable objects, with an erase method and event.

