package Rui::Model::TreeNode;

use Carp;
use Attribute::Protected;
use Rui::Model::Value;
use Rui::Model::List;

use base 'Rui::Model::Base';

# creating -----------------------------------------------------------------

sub init : Protected
{
	my ($self, %params) = @_;
	$self->{valueHolder} = Rui::Model::Value->new(value => $params{value});
	$self->{listHolder}  = Rui::Model::Value->new(
		value  => Rui::Model::List->new(data => ($params{data} || [])),
		attach => 1
	);
	$self->SUPER::init(%params);
}
# accessing ----------------------------------------------------------------

sub list
{
	my ($self, $list) = @_;
	return $self->{listHolder}->value if @_ == 1;
	$self->{listHolder}->value($list);
	return $self;
}

sub value
{
	my ($self, $value) = @_;
	return $self->{valueHolder}->value if @_ == 1;
	$self->{valueHolder}->value($value);
	return $self;
}

sub listHolder  { shift->{listHolder}  }
sub valueHolder { shift->{valueHolder} }

# event handling -----------------------------------------------------------

sub handleEvent_valueHolder_Change
{
   my $self = shift;
   $self->fireEvent(Rui::Event::Value->new(
   	name   => 'Change',
		value  => $self->value,
   	source => $self,
   ));
}

# template methods ---------------------------------------------------------

sub getAttachments : Protected
{{
	valueHolder => {
		Change       => 'Change',
		Value_Change => 'Change',
	},
}}

# --------------------------------------------------------------------------

1;

