package Rui::Model::tests::SelectionInTree;

use Rui::Model::Value;
use Rui::Model::List;
use Rui::Model::TreeNode;
use Rui::Model::Tree;
use Rui::Model::SelectionInTree;

use base qw(Rui::Model::tests::ModelTestCase);

sub getModelClass { 'Rui::Model::SelectionInTree' }

sub makeBigModel
{
	my $self = shift;
	my $protoNode = Rui::Model::TreeNode->new;
	$self->makeModel(tree => Rui::Model::Tree->new( root => $protoNode->new(
		value => 'RootNode',  
		data  => [
			$protoNode->new(
				value => 'Child 1',
				data  => [
					$protoNode->new(value => 'Grandchild 1.1'),
					$protoNode->new(value => 'Grandchild 1.2'),
				],
			),
			$protoNode->new(
				value => 'Child 2',
				data  => [
					$protoNode->new(value => 'Grandchild 2.1'),
					$protoNode->new(value => 'Grandchild 2.2'),
					$protoNode->new(value => 'Grandchild 2.3'),
				],
			
			),
		],
	)));
	return $self->{model};
}

sub test_selectedPath
{
	my $self = shift;
	my $model = $self->makeBigModel;
	$model->selectedNode($model->tree->nodeAt(1, 2));
	
	$self->assert('1.2', join('.', @{$model->selectedPath}));
}

1;


