package Rui::Model::tests::TreeNode;

use Rui::Model::Value;
use Rui::Model::TreeNode;

use base qw(Rui::Model::tests::ModelTestCase);

sub getModelClass { 'Rui::Model::TreeNode' }

sub test_Change
{
	my $self = shift;
	$self->makeModel(
		value => 'RootNode',  
		data  => [
			$self->{model}->new(
				value => 'Child 1',
				data  => [
					$self->{model}->new(value => 'Grandchild 1.1'),
					$self->{model}->new(value => 'Grandchild 1.2'),
				],
			),
			$self->{model}->new(
				value => 'Child 2',
				data  => [
					$self->{model}->new(value => 'Grandchild 2.1'),
					$self->{model}->new(value => 'Grandchild 2.2'),
					$self->{model}->new(value => 'Grandchild 2.3'),
				],
			
			),
		],
	);

	my $event = 44;
	my $callback = sub { $event = shift };
	$self->{model}->addListener(Change => $callback);

	$self->{model}->value('new');
	$self->assert_equals('new', $event->value);
}

sub test_ValueChange
{
	my $self = shift;
	my $value = Rui::Model::Value->new->value('old');
	$self->makeModel(value => $value);
	
	my $event = 44;
	my $callback = sub { $event = shift };
	$self->{model}->addListener(Change => $callback);

	$self->{model}->value(Rui::Model::Value->new(value => 'old'));
	$event = 44;
	$self->{model}->value->value('new');
	$self->assert_equals('new', $event->value->value);
}

1;

