package Rui::View::CheckBox;

use Carp;
use Attribute::Protected;

use base 'Rui::View::TextField';

# creating -----------------------------------------------------------------

sub init : Protected
{
	my ($self, %params) = @_;
	$self->SUPER::init(%params);
	$self->label($params{label}) if exists $params{label};
}

# accessing ----------------------------------------------------------------

sub label { shift->attribute(label => @_) }

# template methods ---------------------------------------------------------

sub getDefaultWidgetClass : Protected { 'CheckBox' }
sub renderValue           : Protected 
{
	my ($self, $value) = @_;
	return $value? 1: 0;
}

# --------------------------------------------------------------------------

1;




