package Rui::View::PerlSource;

use Carp;
use Attribute::Protected;
use Syntax::Highlight::Perl;
use Rui::Util;

use base 'Rui::View::HTMLArea';

sub init : Protected
{
	my ($self, %params) = @_;
	$self->SUPER::init(%params);
	$self->readOnly(1);
	$self->style(backgroundColor => '#000000');
}

sub renderValue : Protected
{
	my ($self, $value) = @_;
	$value =~ s|::|/|g;
	my $fileName = $INC{"$value.pm"};
	croak "cannot find class $value" unless $fileName;

	open(FILE, "$fileName") || croak "cannot open $fileName: [$!]\n";
	my $lines = join '', <FILE>;
	close(FILE) || croak "cannot close $fileName: [$!]\n";
	return Rui::Util::syntaxColor($lines, 1);
}

1;
