package Rui::View::tests::CheckBox;

use base qw(Rui::Widget::tests::TestCase);

sub getSubjectClass { 'CheckBox' }

sub set_up
{
	my $self = shift;
	$self->SUPER::set_up;
	$self->{subject} = $self->createWidget;
	$self->flushBuffer;
}

sub test_value
{
	my $self = shift;
	my $subject = $self->{subject};
	$subject->model->value(1);
	$self->assert_serverBuffer('W1', 'E1', ([qw(value 1)]));
	$subject->model->value(0);
	$self->assert_serverBuffer('W1', 'E1', ([qw(value 0)]));
	$subject->model->value('true');
	$self->assert_serverBuffer('W1', 'E1', ([qw(value 1)]));
	$subject->model->value('');
	$self->assert_serverBuffer('W1', 'E1', ([qw(value 0)]));
}

sub test_label
{
	my $self = shift;
	my $subject = $self->{subject};
	$subject->label("foo");
	$self->assert_serverBuffer('W1', 'E1', ([qw(label foo)]));
}

sub test_readOnly
{
	my $self = shift;
	my $subject = $self->{subject};
	$subject->readOnly(1);
	$self->assert_serverBuffer('W1', 'E1', ([qw(readOnly 1)]));
	$subject->readOnly(0);
	$self->assert_serverBuffer('W1', 'E1', ([qw(readOnly 0)]));
}

1;

