package Rui::Widget::Group;

use Carp;
use Attribute::Protected;

use base 'Rui::Widget::Panel';

# creating -----------------------------------------------------------------

sub init : Protected
{
	my ($self, %params) = @_;
	$self->SUPER::init(%params);
	$self->value($params{value}) if exists $params{value};
}

# accessing ----------------------------------------------------------------

sub value { shift->attribute(value => @_) }

# template methods ---------------------------------------------------------

sub getDefaultWidgetClass : Protected { 'Group' }

# --------------------------------------------------------------------------

1;

=head1 NAME

Rui::Widget::Group - composite widget with label and border

=head1 SYNOPSIS

  $group = $someWindow->Group;
  $group->layoutManager(name => 'grid', numCols => 3);
  $group->value('A Group');
  $group->Label(value => 'foo');

=head1 SUPERCLASS

L<Rui::Widget::Panel>

=head1 DESCRIPTION

A group is just a panel with a border. You can set a text value that
will be displayed on the border.

=cut
