#!/usr/bin/perl -w

use Carp qw(verbose);
use FindBin;
use lib "$FindBin::Bin/../../../base/perllib";

use Rui;
use Rui::Server::HTTP;

my $localPort = 8888;
my $logFile   = "-";  # dump log to stdout
my $pidFile   = undef;
my $isDebug   = 0;

use Getopt::Long;

GetOptions(
	"h|help"       => \&showHelp,
	"p|port=s"     => \$localPort,
	"d|debug"      => \$isDebug,
	"l|log=s"      => \$logFile,
	"i|pid=s"      => \$pidFile,
);

sub showHelp {
	print "The Rui HTTP-based server.\n";
	print "Usage: $0 [OPTIONS]\n";
	print "Options:\n";
	print "\t-h --help          show this help and exit\n";
	print "\t-p --port <port>   set the server port ($localPort)\n";
	print "\t-d --debug         run in development mode\n";
	print "\t-l --log <file>    set the log file ($logFile)\n";
	print "\t-i --pid <file>    set the pid file (*none*)\n";
	exit(0);
}

Rui::Server::HTTP->new(
	IsDebug   => $isDebug,
	LocalPort => $localPort,
	LogFile   => $logFile,
	PidFile   => $pidFile,
)->run;
