
use("Client_Runner");
use("Client_ServerProxy");
use("Widget_LayoutBuffer");

Class("Client_Application");
Class_Singleton();

Client_Application.simulationMode = false;

_.init = function () {
	this.layoutBuffer = Widget_LayoutBuffer.get();
	if (Client_Application.simulationMode) return;

	this.runner  = Client_Runner.get();
	this.server  = new Client_ServerProxy;
		window.status = "Loading UI...";
	var response = this.server.boot();
		window.status = "Running UI...";
	this.runner.run(response.getMessage());
		window.status = "Ready";
}

_.fireEvent = function (event) {
	if (Client_Application.simulationMode) {
		this.layoutBuffer.doLayout();
		return;
	}
	this.runner.run(this.server.event(event).getMessage());
}

