
use("Client_ServerResponse");

Class("Client_ServerProxy");

_.init = function () {
	this.requestCount    = 0;
	this.xml             = new ActiveXObject("Microsoft.XMLDOM");
	var parts            = location.search.substr(1).split("\|");
	this.applicationName = parts[0] || false;
	this.serverType      = parts[1] || false;
	if (
		this.serverType &&
		this.serverType != 'perl' && this.serverType != 'java'
	) Throw("Uknown server type: " + serverType);
	this.requestPrefix = "rui" + (
		this.serverType?
			(this.serverType == "java")? "Java":
			(this.serverType == "perl")? "Perl":
			"": ""
	) + "?";
}

_.boot =  function (applicationName) {
	this.applicationName = applicationName || this.applicationName;
	this.sessionId = false;
	var event = {
		"requestType": "boot",
		"clientType" : VERSION.IE6up? "IE6": "NS6"
	};
	if (this.applicationName)
		event.applicationName = this.applicationName;

	return this.request(event);
}

_.event = function (event) {
	event.requestType = "event";
	return this.request(event);
}

_.request = function (event) { try {
	if (this.sessionId) event.sessionId = this.sessionId;
	event.requestCount = ++this.requestCount;
	var payloadXML     = this.getPayloadAsXML(event);
	var rawResponse    = Util_Conduit.get().
		request(this.requestPrefix, payloadXML);
	var response       = new Client_ServerResponse(rawResponse);
	this.sessionId     = response.getSessionId();
	return response;
} catch (e) { Throw(e, "While requesting from conduit:" + payloadXML.xml) } }

_.getPayloadAsXML = function (event) {
	var xml = this.xml;
	xml.loadXML("<rui></rui>");
	var root = xml.documentElement;

	var key, value;
	for (key in event) {
		var element = xml.createElement(key);
		element.text = event[key];
		root.appendChild(element);
	}
	return xml;
}
