
use("Widget_Base");

Class("Widget_CheckBox", "Widget_Base");

// creating -------------------------------------------------------------------

_.populate = function () {
	var label        = this.createElement("label");
	var check        = this.createElement(this.getCheckCreateString());
	var checkId      = this.id + "_Check";
	label.className  = this.getWidgetClass() + "_Label";
	check.className  = this.getWidgetClass() + "_Check";
	check.type       = this.getInputType();
	check.id         = checkId;
	label.htmlFor    = checkId;
	check.onclick    = this.onClick;
	this.element.insertBefore(check);
	this.element.insertBefore(label);
}

_.destroy = function (dontPaint) {
	this.element.firstChild.onclick = null;
	this.Widget_Base_destroy(dontPaint);
}

// accessing ------------------------------------------------------------------

_.value = function (value)
	{ this.element.firstChild.checked = value != "0"? true: false }

_.readOnly = function (value)
	{ this.element.firstChild.readOnly = value != "0"? true: false }

_.hAlign = function (value)
	{ this.element.lastChild.style.textAlign = value }

_.label = function (value) {
	this.element.lastChild.innerText = value;
	this.layoutChanged();
}

// events ---------------------------------------------------------------------

_.onClick = function () {
	me = this.parentElement.me;
	me.fireEvent({
		"name"    : "Change",
		"sourceId": me.id,
		"value"   : (me.getValue()? 1: 0)
	});
	return true;
}

// testing --------------------------------------------------------------------

_.getValue    = function () { return this.element.firstChild.checked };
_.getReadOnly = function () { return this.element.firstChild.readOnly };
_.getLabel    = function () { return this.element.lastChild.innerText };

// template methods -----------------------------------------------------------

_.getTag               = function () { return "div" }
_.getWidgetClass       = function () { return "CheckBox" }
_.isSelectable         = function () { return false }
_.getInputType         = function () { return "checkbox" }
_.getCheckCreateString = function () { return "input" }
_.clear                = function () { this.element.firstChild.checked = false }

