
Class("Widget_Group", "Widget_Panel");

// hack! only work when group is with default font
Widget_Group.headHeight = 13;
// hack! work only when margins are 4px in css
Widget_Group.bodyMargin = 8;

// creating -------------------------------------------------------------------

_.populate = function () {
	this.Widget_Panel_populate();
	var element = this.element;
	this.head = this.createElement("legend");
	this.body = this.createElement("div");
	this.body.className = this.getWidgetClass() + "_Body";
	element.insertBefore(this.head);
	element.insertBefore(this.body);
}

_.destroy = function (dontPaint) {
	this.head = undefined;
	this.body = undefined;
	this.Widget_Panel_destroy(dontPaint);
}

_.clear = function () { if (this.body) this.clearElementChildren(this.body) }

// accessing ------------------------------------------------------------------

_.value = function (value) {
	this.element.firstChild.innerText = value;
	this.layoutChanged();
}

_.getValue = function () { return this.element.firstChild.innerText; }

// layout ---------------------------------------------------------------------

_.setChildrenBounds = function () {
	var bodyWidth    = this.layout.cache.innerWidth  - Widget_Group.bodyMargin; 
	var bodyHeight   = this.layout.cache.innerHeight -	Widget_Group.bodyMargin - Widget_Group.headHeight;

	var bodyStyle    = this.getMainElement().style;
	bodyStyle.width  = bodyWidth  < 0? "0px": bodyWidth + "px";
	bodyStyle.height = bodyHeight < 0? "0px": bodyHeight + "px";
	bodyStyle.top    = Widget_Group.headHeight + "px";
	this.Widget_Panel_setChildrenBounds();
}

_.computeMinWidth = function ()
	{ return this.Widget_Panel_computeMinWidth() + Widget_Group.bodyMargin }

_.computeMinHeight = function ()
	{ return this.Widget_Panel_computeMinHeight() + Widget_Group.bodyMargin + Widget_Group.headHeight }

_.getChildrenAreaWidth  = function ()
	{ return this.layout.cache.innerWidth - Widget_Group.bodyMargin }

_.getChildrenAreaHeight = function ()
	{ return this.layout.cache.innerHeight - Widget_Group.bodyMargin - Widget_Group.headHeight }

// template methods -----------------------------------------------------------

_.getTag         = function () { return "fieldset" }
_.getWidgetClass = function () { return "Group" }
_.getMainElement = function () { return this.element.lastChild }

