
use("Widget_Label");

Class("Widget_Layout_tests_Row", "Widget_Layout_tests_TestCase");

Widget_Layout_tests_Row.defaultSpacing = 3;

_.getLayoutManagerName = function () { return "row" }

_.test3Children = function () {
	var child1 = new Widget_Label("W2", this.subject);
	var child2 = new Widget_Label("W3", this.subject);
	var child3 = new Widget_Label("W4", this.subject);
	child1.value("Hello World");
	child2.value("Hello WorldHello World");
	child3.value("Hello WorldHello WorldHello World");
	this.assertEquals(
		"min width",
		this.getHelloWorldWidth() * 6 + Widget_Layout_tests_Row.defaultSpacing * 2,
		this.subject.getMinWidth()
	);
	this.assertEquals
		("min height", this.getCharHeight(), this.subject.getMinHeight());
}

_.test3ChildrenNoPack = function () {
	this.subject.layoutManager("pack", "0");
	var child1 = new Widget_Label("W2", this.subject);
	var child2 = new Widget_Label("W3", this.subject);
	var child3 = new Widget_Label("W4", this.subject);
	child1.value("Hello World");
	child2.value("Hello WorldHello World");
	child3.value("Hello WorldHello WorldHello World");
	this.assertEquals(
		"min width",
		this.getHelloWorldWidth() * 9 + Widget_Layout_tests_Row.defaultSpacing * 2,
		this.subject.getMinWidth()
	);
	this.assertEquals
		("min height", this.getCharHeight(), this.subject.getMinHeight());
}
