
use("Widget_WindowManager");
use("Widget_LayoutBuffer");
use("Widget_Window");
use ("Widget_Panel");
use ("Widget_Label");

Class("Widget_Layout_tests_TestCase", "Widget_tests_TestCase");

// template methods -----------------------------------------------------------

_.getSubjectClass      = function () { return Widget_Panel }
_.getLayoutManagerName = function () { Throw("Abstract method called") }

// framework methods ----------------------------------------------------------

_.setUp = function () {
	this.Widget_tests_TestCase_setUp();
	this.subject.layoutManager("name", this.getLayoutManagerName());
}

_.create3Children = function (orient) {
	var child1 = new Widget_Label("W2", this.subject);
	var child2 = new Widget_Label("W3", this.subject);
	var child3 = new Widget_Label("W4", this.subject);
	child1.value("Hello World");
	child2.value("Hello WorldHello World");
	child3.value("Hello WorldHello WorldHello World");
	if (orient) this.subject.layoutManager("orient", orient);
	return [child1, child2, child3];
}

_.assertChildrenWidth = function (children, width) {
	this.doLayout();
	this.assertEquals("width 1", width[0], this.getWidgetWidth(children[0]));
	this.assertEquals("width 2", width[1], this.getWidgetWidth(children[1]));
	this.assertEquals("width 3", width[2], this.getWidgetWidth(children[2]));
}

_.assertChildrenHeight = function (children, height) {
	this.doLayout();
	this.assertEquals("height 1", height[0], this.getWidgetHeight(children[0]));
	this.assertEquals("height 2", height[1], this.getWidgetHeight(children[1]));
	this.assertEquals("height 3", height[2], this.getWidgetHeight(children[2]));
}

// default tests --------------------------------------------------------------

_.test1Child = function () {
	var child = new Widget_Label("W2", this.subject);
	child.value("Hello World");
	this.assertEquals
		("min width", this.getHelloWorldWidth(), this.subject.getMinWidth());
	this.assertEquals
		("min height", this.getCharHeight(), this.subject.getMinHeight());
}

