
use("Widget_WindowManager");

Class("Widget_List_Controller_Single");
Class_Singleton();

// accessing  -----------------------------------------------------------------

_.removeItem = function (list, item)
	{ if (item.id == list.selectedId) list.selectedId = -1 }

_.selectItem = function (list, item) {
	var oldId = list.selectedId;
	if (oldId && oldId != -1) this.deselectItem
		(list, Widget_WindowManager.get().getWidget(list.window.getId(), oldId));
	if (item == -1 ) {
		list.selectedId = -1;
		return;
	}
	list.selectedId = item.id;
	item.select();
}

_.deselectItem = function (list, item) {
	item.deselect();
	item.element.tabIndex  = -1;
}

// event handling -------------------------------------------------------------

_.onClick = function (list, index, shiftOn, ctrlOn) { 
	var oldId  = list.selectedId;
	var newId  = list.getChild(index).getId();
	if (oldId == newId) return false;
	var newItem =
		Widget_WindowManager.get().getWidget(list.window.getId(), newId);
	this.selectItem(list, newItem);
	newItem.focus();
	var event = {
		"name"          : "SelectionChanged",
		"sourceId"      : list.id,
		"selectedIndex" : index
	};
	return event;
}
