
use("Widget_NoteBook_Tab");

Class("Widget_NoteBook_Header", "Widget_Panel");

// creating -------------------------------------------------------------------

_.populate = function () {
	this.Widget_Panel_populate();
	this.oldSelected            = -1;
	this.selected               = -1;
	this.layout.manager.spacing = 0;
}

// accessing ------------------------------------------------------------------

_.selectedIndex = function (index) {
	var selected    = this.getChild(index);
	var oldSelected = this.oldSelected;
	if (oldSelected == selected) return;
	if (oldSelected != -1) {
		oldSelected.deselect(oldSelected);
		oldSelected.layout.hint.extraHeight = 0;
		var oldIndex = this.getIndexOfChild(oldSelected);
		if (oldIndex > 0)
			this.getChild(oldIndex - 1).element.runtimeStyle.
				borderRightWidth = "";
		if (oldIndex < this.childCount() - 1)
			this.getChild(oldIndex + 1).element.runtimeStyle.
				borderLeftWidth = "";
	}
	selected.select(selected);
	this.selected    = selected;
	this.oldSelected = selected;
	selected.layout.hint.extraHeight = 4;
	if (index > 0)
		this.getChild(index - 1).element.runtimeStyle.
			borderRightWidth = "0px";
	if (index < this.childCount() - 1)
		this.getChild(index + 1).element.runtimeStyle.
			borderLeftWidth = "0px";
	this.layoutChanged();

}

_.getSelectedTab = function () { return this.selected }

// compositing ----------------------------------------------------------------

_.add = function (child, index) {
	this.Widget_Panel_add(child, index);
	if (this.childCount() == 1) this.selectedIndex(0);
}

// template methods -----------------------------------------------------------

_.getWidgetClass = function () { return "NoteBook_Header" }
