
use("Widget_Base");

Class("Widget_TextArea", "Widget_Base");

// creating -------------------------------------------------------------------

_.populate = function () {
	this.element.onchange = this.onChange;
	this.hasText          = false;
}

_.destroy = function (dontPaint) {
	this.element.onchange = null;
	this.Widget_Base_destroy(dontPaint);
}

// accessing ------------------------------------------------------------------

_.value = function (value) { this.element.value = value.replace(/\n/g, "\r") }

_.append = function (value)
	{ this.element.value += value.replace(/\n/g, "\r") }

_.insert = function (value)
	{ this.element.value = value.replace(/\n/g, "\r") + this.element.value }

_.readOnly = function (value)
	{ this.element.readOnly = value != "0"? true: false }

// layout ---------------------------------------------------------------------

_.computeMinWidth  = function () { return 80 }
_.computeMinHeight = function () { return 100 }

// events ---------------------------------------------------------------------

_.onChange = function () {
	me = this.me;
	if (me.getIsDisabled()) return;
	me.fireEvent({
		"name"    : "Change",
		"sourceId": me.id,
		"value"   : this.value
	});
	return true;
}

// testing --------------------------------------------------------------------

_.getValue = function () { return this.element.value }

// template methods -----------------------------------------------------------

_.getTag         = function () { return "textarea" }
_.getWidgetClass = function () { return "TextArea" }
_.clear          = function () { this.element.innerText = "" }

