
Class("Widget_TextField", "Widget_Base");

// creating -------------------------------------------------------------------

_.populate = function () {
	this.element.type     = this.getInputType();
	this.element.onchange = this.onChange;
	this.element.value    = "";
}

_.destroy = function (dontPaint) {
	this.element.onchange = null;
	this.Widget_Base_destroy(dontPaint);
}

// accessing ------------------------------------------------------------------

_.value = function (value) { this.element.value = value }

_.readOnly = function (value)
	{ this.element.readOnly = value != "0"? true: false }

// layout ---------------------------------------------------------------------

_.computeMinWidth = function () { return 80 }

// events ---------------------------------------------------------------------

_.onChange = function () {
	me = this.me;
	if (me.getIsDisabled()) return;
	me.fireEvent({
		"name"    : "Change",
		"sourceId": me.id,
		"value"   : this.value
	});
	return true;
}

// testing --------------------------------------------------------------------

_.getValue = function () { return this.element.value }

// template methods -----------------------------------------------------------

_.getTag         = function () { return "input" }
_.getWidgetClass = function () { return "TextField" }
_.getInputType   = function () { return "text" }
_.clear          = function () { this.element.value = "" }
