
use("Widget_Tree_NodeHead");
use("Widget_Tree_NodeBody");

Class("Widget_Tree_Node", "Widget_Panel");

// creating -------------------------------------------------------------------

_.populate = function () {
	this.Widget_Panel_populate();
	var head = new Widget_Tree_NodeHead(this.id + "_Head", this);
	var body = new Widget_Tree_NodeBody(this.id + "_Body", this);
	body.hide();
}

// accessing ------------------------------------------------------------------

_.value = function (value) { this.getHead().value(value) }

_.getHead = function () { return this.firstChild() }
_.getBody = function () { return this.lastChild() }

// selection ------------------------------------------------------------------

_.select   = function () { this.getHead().select() }
_.deselect = function () { this.getHead().deselect() }

// node management ------------------------------------------------------------

_.flip = function () {
	var state = this.getHead().getButtonState();
	if (state == "N") return;
	if (state == "C") { this.expand() } else { this.collapse() }
}

_.nodeCountUp = function () {
	var head = this.getHead();
	var state = head.getButtonState();
	if (state == "C" || state == "O") return;
	head.setButtonState("C");
}

_.nodeCountDown = function () {
	var body = this.getBody();
	if (body.hasChildren()) return;
	var head  = this.getHead();
	var state = head.getButtonState();
	if (state == "O") body.hide();
	head.setButtonState("N");
}

_.expand = function () {
	this.getBody().show();
	this.getHead().setButtonState("O"); 
}

_.collapse = function () {
	this.getBody().hide();
	this.getHead().setButtonState("C"); 
}

_.focus = function () { this.getHead().focus() }
_.blur  = function () { this.getHead().blur()  }

_.getButtonState = function () { return this.getHead().getButtonState() }

// template methods -----------------------------------------------------------

_.getWidgetClass      = function () { return "Tree_Node" }
_.defaultBubbleLayout = function () { return false }
_.getDefaultLayout    = function () { return "null"   }

