
use ("Widget_Label");

Class("Widget_tests_Label", "Widget_tests_TestCase");

_.getSubjectClass = function () { return Widget_Label }

_.testValue = function () {
	this.subject.value("foo");
	this.assertEquals("value", "foo", this.subject.getValue());
}

_.testComputeMinWidth1 = function () {
	this.subject.value("Hello World");
	this.assertEquals(
		"HelloWorld",
		this.getHelloWorldWidth(),
		this.subject.computeMinWidth()
	);
}

_.testComputeMinWidth2 = function () {
	this.subject.value("Hello WorldHello World");
	this.assertEquals(
		"HelloWorld X 2",
		this.getHelloWorldWidth() * 2,
		this.subject.computeMinWidth()
	);
}

_.testComputeMinWidth3 = function () {
	this.subject.value("Hello World");
	this.subject.style("borderLeft","3px solid green");
	this.subject.style("borderRight","17px solid green");
	this.assertEquals(
		"HelloWorld border-left: 3px, border-right: 17px",
		this.getHelloWorldWidth() + 3 + 17,
		this.subject.computeMinWidth()
	);
}

_.testComputeMinWidth4 = function () {
	this.subject.value("Hello World");
	this.subject.style("marginLeft","7px");
	this.subject.style("marginRight","13px");
	this.assertEquals(
		"HelloWorld margin-left: 7px, margin-right: 13px",
		this.getHelloWorldWidth() + 7 + 13,
		this.subject.computeMinWidth()
	);
}

_.testComputeMinWidth5 = function () {
	this.subject.value("Hello World");
	this.subject.style("paddingLeft","11px");
	this.subject.style("paddingRight","4px");
	this.assertEquals(
		"HelloWorld padding-left: 11px, padding-right: 4px",
		this.getHelloWorldWidth() + 11 + 4,
		this.subject.computeMinWidth()
	);
}

_.testComputeMinWidth6 = function () {
	this.subject.value("Hello World");
	this.subject.style("padding","0px 3px 0px 17px");
	this.subject.style("margin","0px 23px 0px 5px");
	this.subject.style("borderRight","11px solid green");
	this.subject.style("borderLeft","29px solid green");
	this.assertEquals(
		"HelloWorld with everything",
		this.getHelloWorldWidth() + 3 + 17 + 23 + 5 + 11 + 29,
		this.subject.computeMinWidth()
	);
}


_.testComputeMinHeight1 = function () {
	this.subject.value("Hello World");
	this.assertEquals(
		"HelloWorld",
		this.getCharHeight(),
		this.subject.computeMinHeight()
	);
}

_.testComputeMinHeight2 = function () {
	this.subject.value("Hello World");
	this.subject.style("padding","3px 0px 17px 0px");
	this.subject.style("margin","23px 0px 5px 0px");
	this.subject.style("borderTop","11px solid green");
	this.subject.style("borderBottom","29px solid green");
	this.assertEquals(
		"HelloWorld with everything",
		this.getCharHeight() + 3 + 17 + 23 + 5 + 11 + 29,
		this.subject.computeMinHeight()
	);
}

_.testComputeMinSizeImageNoText = function () {
	this.subject.image("images/icons/Folder.gif");
	this.subject.imageWidth(50);
	this.subject.imageHeight(40);
	this.assertEquals("width",  50, this.subject.computeMinWidth());
	this.assertEquals("height", 40, this.subject.computeMinHeight());
}
