
use ("Widget_SelectBox");

Class("Widget_tests_SelectBox", "Widget_tests_TestCase");

_.getSubjectClass = function () { return Widget_SelectBox }

_.testComputeMinHeight = function () {
	this.subject.insert(0,"foo");
	this.subject.insert(1,"bar");
	this.assertEquals(
		"HelloWorld",
		this.getCharHeight() + this.getTextFieldExtraHeight(),
		this.subject.computeMinHeight()
	);
}

_.testFill = function () {
	var parent = new Widget_Panel("E2", this.window);
	parent.layoutManager("name", "fill");
	var selectBox1  = this.createSubject("E3", parent);
	var selectBox2  = this.createSubject("E4", parent);
	this.subject.insert(0, "foo");
	this.subject.insert(0, "bar");
	this.doLayout();
	this.assertEquals(
		"selectBox1",
		this.getWindowWidth()/2,
		selectBox1.element.offsetWidth
	);
	this.assertEquals(
		"selectBox2",
		this.getWindowWidth()/2,
		selectBox2.element.offsetWidth
	);
}

_.testHasChildren = function () {
	this.subject.insert(0, "foo");
	this.assertEquals("yes children", true, this.subject.hasChildren());
}

_.testSelectedIndex = function () {
	this.subject.insert(0, "foo0");
	this.subject.insert(0, "foo1");
	this.subject.insert(0, "foo2");

	this.subject.selectedIndex(0);
	this.assertEquals("wrong selection", 0, this.subject.element.selectedIndex);
}

// check the implementation of unselected item
_.testSelectedIndex1 = function () {
	this.subject.insert(0, "foo0");
	this.subject.insert(0, "foo1");
	this.subject.insert(0, "foo2");
	this.subject.insert(0, "foo3");
	this.subject.selectedIndex(2);
	this.subject.removeByIndex(2);
	this.assertEquals("wrong selection", 0, this.subject.element.selectedIndex);
	this.subject.insert(0,"foo4");
	this.assertEquals("wrong selection", 0, this.subject.element.selectedIndex);
	this.subject.selectedIndex(2);
	this.subject.insert(0, "foo5");
	this.assertEquals("wrong selection", 3, this.subject.element.selectedIndex);
}
