
use("Widget_WindowManager");
use("Widget_LayoutBuffer");
use("Widget_Window");

Class("Widget_tests_TestCase", "Test_Case");

// template methods -----------------------------------------------------------

_.getSubjectClass = function () { Throw("Abstract method called") }

// testing --------------------------------------------------------------------

_.setUp = function () {
	try { this.window.destroy() } catch (e) {}
	window.resizeTo(640, 480);
	this.window     = new Widget_Window("W1");
	this.winManager = Widget_WindowManager.get();
	this.buffer     = Widget_LayoutBuffer.get();
	this.subject    = this.createSubject("E1");
}

_.tearDown = function () { this.window.destroy() }

_.testCreate = function () {
	this.assertEquals("id","E1", this.subject.getId());
	this.assertEquals("window", this.window, this.subject.getWindow());
	this.assertEquals("window get", this.subject, this.window.getWidget("E1"));
	this.assertEquals
		("winManager get", this.subject, this.winManager.getWidget("W1", "E1"));

	this.subject.destroy();
	var flag = false;
	try { subject = this.getWidget("W1","E1") }
		catch (e) { flag = true }
	this.assert("widget found after destroy", flag);
	this.subject = this.createSubject("E1");
}

// utilities ------------------------------------------------------------------

_.createSubject = function (id, parent, addArg1) {
	var subjectClass = this.getSubjectClass();
	return new subjectClass(id, parent? parent: this.window, addArg1);
}

_.getWidgetWidth  = function (widget)  { return widget.layout.cache.innerWidth }
_.getWidgetHeight = function (widget) { return widget.layout.cache.innerHeight }

_.getWidget = function (windowId, widgetId) { return this.window.getWidget(windowId, widgetId) }
_.getWindow = function (windowId)           { return this.window.getWindow(windowId) }

_.getMinWidth  = function (widget) { return widget.getMinWidth() }
_.getMinHeight = function (widget) { return widget.getMinHeight() }

_.getHelloWorldWidth      = function () { return 54 } // for font: normal normal normal 11px tahoma;
_.getCharHeight           = function () { return 13 } // for font: normal normal normal 11px tahoma;
_.getTextFieldExtraHeight = function () { return 6 }
_.getWindowWidth          = function () { return document.body.offsetWidth }
_.getWindowHeight         = function () { return document.body.offsetHeight }
_.doLayout                = function () { this.buffer.doLayout() }
