
use("Widget_WindowManager");
use("Widget_Window");

Class("Widget_tests_Window", "Test_Case");

_.setUp = function () {
	this.subject = new Widget_Window("W1");
	this.manager = Widget_WindowManager.get();
}

_.tearDown = function () { this.subject.destroy() }

_.testCreate = function () {
	var subject2 = new Widget_Window("W2","100","100","1");
	var subject3 = new Widget_Window("W3","150","150","0");
	this.assertEquals("main id 1"  , "W1", this.subject.id);
	this.assertEquals("main id 2"  , "W1", this.manager.getWindow("W1").id);
	this.assertEquals("second id 1", "W2", subject2.id);
	this.assertEquals("second id 2", "W2", this.manager.getWindow("W2").id);
	this.assertEquals("third id 1" , "W3", subject3.id);
	this.assertEquals("third id 2" , "W3", this.manager.getWindow("W3").id);
	var flag = false;
	try { this.manager.getWindow("W4") } catch(e) { flag = true }
	this.assert("non-existing window", flag);
}

_.testClose = function () {
	var subject2 = new Widget_Window("W2");
	subject2.destroy();
	var flag = false;
	try { this.manager.getWindow("W2") } catch(e) { flag = true }
	this.assert("close", flag);
}

_.testTitle = function () {
	this.subject.title("foo");
	this.assertEquals("set title 1", "foo", this.subject.getTitle());
	this.subject.title("bar");
	this.assertEquals("set title 2", "bar", this.subject.getTitle());
}
